<?php
/*
Plugin Name: MigaWP
Description: This plugin is reserved fo Migastone Users. Activate it for generate autologin link.
Author: Migastone
Version: 1.0.20
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/
require_once ABSPATH . WPINC . "/class-phpass.php";

require_once ABSPATH  . "/wp-includes/pluggable.php";

define('PKG_migawp_VALUE_NAME', 'migawp_code');

define('PKG_migawp_LANGUAGE_DOMAIN', 'pkg_migawp');

define('PKG_migawp_USER_META_KEY', 'pkg_migawp_code');

define('PKG_migawp_CODE_CHARACTERS', "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

$met_key_name="pkg_migawp_code";

global $wpdb;

if( !session_id() )
    session_start();

        //**SECTION 3 add error text **//
//While get an wrong token try return add error Text
add_action('login_head', 'pkg_migawp_extract_login_link_error');
function pkg_migawp_extract_login_link_error() {
  global $errors;
  if (isset($_GET['pkg_migawp_error'])) {
    $rawMsg = $_GET['pkg_migawp_error'];
    // Check if valid pkg_migawp_error
    if (in_array($rawMsg, array('invalid_login_code','deleted_from_siberian','bind_user','missing_data'))) {
      $secureMsg = $rawMsg;
      // Add error texts
      switch ($secureMsg) {
        case 'invalid_login_code':
          $errors->add("invalid_migawp_link", "System detected this URL paused for autologin.<br>Please delete and regenrate the link for autologin.");
          break;
          case 'deleted_from_siberian':
          $errors->add("invalid_migawp_link", "System detected that you did not bind any user with this URL.Please go back to your app and bind User correctly.");
          break;
          case 'bind_user':
          $errors->add("invalid_migawp_link", "First you have to lolgin with user you want to bind with your app user.");
          break;
          case 'missing_data':
          $errors->add("invalid_migawp_link", "You must have to bind token correctely.");
          break;
      }
    }
  }
}
        //**SECTION 4 add error text **//


      //**SECTION 5 Remove token on Deactivation **//
// Hook general init to login users if an migawp code is specified
function myplugin_deactivate() {
  $token_exist              = get_user_meta( 1, 'pkg_migawp_code', true );
  $platform_url              = get_user_meta( 1, 'platform_url', true );
  $curl                     = curl_init();
              curl_setopt_array($curl, array(
                CURLOPT_URL => $platform_url."/migawordpress/public_api/ondeactivation?token=".$token_exist,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "",
                CURLOPT_HTTPHEADER => array("cache-control: no-cache"),
              ));
              $response   = curl_exec($curl);
              $err        = curl_error($curl);
              curl_close($curl);
              $meta_type  = 'user';
              $user_id    = 1;
              $meta_key   = 'pkg_migawp_code';
              $meta_value = '';
              $delete_all = false;
              delete_metadata( $meta_type, $user_id, $meta_key, $meta_value, $delete_all );
              delete_metadata( $meta_type, $user_id, 'platform_url', $platform_url, $delete_all );
}
register_deactivation_hook( __FILE__, 'myplugin_deactivate' );
function pkg_migawp_generate_get_postfix() {
  $GETcopy = $_GET;
  unset($GETcopy[PKG_migawp_VALUE_NAME]);
  $GETQuery = pkg_migawp_join_get_parameters($GETcopy);
  if (strlen($GETQuery) > 0) {
    $GETQuery = '?' . $GETQuery;
  }
  return $GETQuery;
}
function pkg_migawp_join_get_parameters($parameters) {
  $keys = array_keys($parameters);
  $assignments = array();
  foreach ($keys as $key) {
    $assignments[] = "$key=$parameters[$key]";
  }
  return implode('&', $assignments);
}

// Plugin Version 2
  require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

// Section 0 Validate during save url
if (isset($_GET['validateurlmigawp'])) {
  echo json_encode($_GET['validateurlmigawp']);
  exit;
}
// Section 1 Create table on Plugin activation
  function create_table() {
      global $wpdb;
      $table_name      = $wpdb->prefix . 'migstone_auto_login';
      $charset_collate = $wpdb->get_charset_collate();
      /*
      *COLUMN request_type 1,For Owner end
      *NOTE:Update in table schema will update auto and add column at the end
      */
      $sql = "CREATE TABLE $table_name (
              id mediumint(9) NOT NULL AUTO_INCREMENT,
              platform_url varchar(150) DEFAULT '' NOT NULL,
              site_url varchar(150) DEFAULT '' NOT NULL,
              login_url varchar(150) DEFAULT '' NOT NULL,
              token varchar(50) DEFAULT '' NOT NULL,
              request_type int NOT NULL,
              app_id int NOT NULL,
              migastone_user_id varchar(100) DEFAULT '0' NOT NULL,
              wordpress_user_id varchar(100) DEFAULT '0' NOT NULL,
              token_type int NOT NULL,
              created_at datetime DEFAULT CURRENT_TIMESTAMP NOT NULL,
              updated_at datetime ,
              is_deleted int NOT NULL,
              token_bind int NOT NULL,
              PRIMARY KEY  (id))";
      dbDelta( $sql );
  }
  register_activation_hook( __FILE__, 'create_table' );

// Section 2 Handle request form Owner side for Save url
/*
*type _GET
*Param site_url Having the site URL which will be configure
*Param platform_url Having the migastone platform URL
*Param app_id App id of Platform
*Param user This can be Wordpress site user in case of SPECIFIC USER option selected by appowner or will be a constant string in case of app user bind appuser
*return
*array error yes for User not exist,data not inserted,
*array error no for success insertion
*/
  if (isset($_GET['site_url']) && isset($_GET['platform_url']) && isset($_GET['app_id'])) {
    $response     = ['error'=>false];
    $platform_url = urldecode($_GET['platform_url']);
    $site_url     = urldecode($_GET['site_url']);
    $app_id       = $_GET['app_id'];
    $wp_user      = $_GET['user'];
    $token        = $_GET['token'];
    $login_url    = urldecode($_GET['login_url']);
  	$table_name   = $wpdb->prefix . 'migstone_auto_login';

    if ($wp_user=="appuser") {
        $user_id='0';
        // $token  = "token";
        $token_type  =2;
    } else {
      $token_type=1;
      $user_exist = get_user_by( 'login', $wp_user );
      if (!empty($user_exist)) {
          $user_id      = $user_exist->data->ID;
        }else {
          $response=['error'=>true,'message'=>"This user not exist.Please provide a valid user."];
        }
        // $token = bin2hex(random_bytes(16));
    }

  	if (!$response['error']) {
      $response_insert=$wpdb->insert(
    		$table_name,
    		array(
    			'platform_url'      => $platform_url,
    			'site_url'          => $site_url,
    			'login_url'         => $login_url,
    			'token'             => $token,
    			'request_type'      => 1,
    			'app_id'            => $app_id,
    			'migastone_user_id' => 0,
    			'is_deleted'        => 0,
    			'wordpress_user_id' => $user_id,
    			'token_type'        => $token_type,
    			'token_bind'        => 0
    		)
    	);
       // $wpdb->show_errors();
       // $wpdb->print_error();
      $lastid = $wpdb->insert_id;
      if ($lastid) {
        $response=['error'=>false,'inserted_id'=>$lastid,'token'=>$token,'user_id'=>$user_id];
      } else {
        $response=['error'=>true,'message'=>"Could not save URL",'other'=>$response_insert];
      }
    }

    echo json_encode($response);
    exit;
  }

// Section 3 Handle request form Owner side for remove url
/*
*type _GET
*Param remove_key Thi will be id index for remove
*/
  if (isset($_GET['remove_key'])) {
    $remove_key   = $_GET['remove_key'];
  	$table_name   = $wpdb->prefix . 'migstone_auto_login';

  	$updated =$wpdb->update(
  		            $table_name,
  		            array('is_deleted'=> 1),
                  array('id'=> $remove_key)
  	             );
    if ( false === $updated ) {
      $response=['error'=>'yes','data'=>"Could not Remove.Please try again later."];
    } else {
      $response=['error'=>'no','data'=>"Successfully remove data."];
    }
    echo json_encode($response);
    exit;
  }
  add_action('after_setup_theme', 'remove_admin_bar');

  function remove_admin_bar() {
  if (!current_user_can('administrator') && !is_admin()) {
    show_admin_bar(false);
  }
  }
// Section 4 Handle request form APP side for login or register
/*
*type _GET
*This logic do the followinf actions
*Check either this reuqest form app end is for register or login auto
*@First Register
*Put the _GET data in _SESSION and redirect to Manual login first time
*/
// Hook general init to login users if an migawp code is specified
add_action('init', 'pkg_migawp_authenticate');
function pkg_migawp_authenticate() {
  // Check if migawp link is specified - if there is one the work begins
  global $wpdb;
  if (isset($_GET[PKG_migawp_VALUE_NAME])) {
      $migawp_code = preg_replace('/[^a-zA-Z0-9]+/', '', $_GET[PKG_migawp_VALUE_NAME]);
    if ($migawp_code) { // Check if not empty
      // Get part left of ? of the request URI for resassembling the target url later
      $subURIs = array();
      if (preg_match('/^([^\?]+)\?/', $_SERVER["REQUEST_URI"], $subURIs) === 1) {
        // Query login codes
        $table_name   = $wpdb->prefix . 'migstone_auto_login';
        $query="SELECT token as login_code, wordpress_user_id as user_id,site_url,login_url FROM $table_name WHERE token='$migawp_code'  ORDER BY id DESC LIMIT 1";
        $userIds = array();
        $results = $wpdb->get_results($query, ARRAY_A);

        if ($results === NULL) {
          wp_dir("Query failed!");
        }
        if (empty($results)) {
          $protocol = stripos($_SERVER['SERVER_PROTOCOL'],'https') === 0 ? 'https://' : 'http://';
          $domain = $_SERVER['SERVER_NAME'];
          $redirect_url=$protocol.$domain;
          wp_logout();
          wp_redirect($redirect_url.'/wp-admin/?pkg_migawp_error=missing_data');
          exit;
        }
        foreach ($results as $row) {
          if ($row["login_code"] === $migawp_code) {
            $userIds[]   = $row["user_id"];
            $targetPage  = $row['site_url'];
            $targetLogin = $row['login_url'];
          }
        }

        // Double login codes? should never happen - better safe than sudden admin rights for someone :D
        // if ($token_bind==0) {
        //   wp_die("Please login normally - You should add bind token from your Wordpress admin settings!"); // TODO !!!
        // }
        // Only login if there is only ONE possible user
        if (count($userIds) == 1) {
          $userToLogin = get_user_by('email', (string ) $_GET['user_email']);//Hving id like 1
          // Check if user exists
          if ($userToLogin) {
            wp_set_auth_cookie($userToLogin->ID, false);
            do_action('wp_login', $userToLogin->name, $userToLogin);
            // Create redirect URL without migawp code
            $GETQuery = pkg_migawp_generate_get_postfix();
            $protocol = (isset($_SERVER["HTTPS"]) && ($_SERVER["HTTPS"] === "on")) ? "https" : "http";
            header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
            header("Cache-Control: no-cache, no-store, must-revalidate, private, max-age=0, s-maxage=0");
            header("Cache-Control: post-check=0, pre-check=0", false);
            header("Pragma: no-cache");
            header("Expires: Mon, 01 Jan 1990 01:00:00 GMT");
            wp_redirect($_GET['url']);

            add_filter('show_admin_bar', '__return_false');
            exit;
          }
        }
      }
    }


    $query="SELECT token as login_code, wordpress_user_id as user_id FROM $table_name WHERE token='$migawp_code'";
        $userIds = array();
        $results = $wpdb->get_results($query, ARRAY_A);

        if ($results === NULL) {
          wp_dir("Query failed!");
        }
        foreach ($results as $row) {
          if ($row["login_code"] === $migawp_code) {
            $userIds[] = $row["user_id"];
          }
        }

        // Double login codes? should never happen - better safe than sudden admin rights for someone :D
        if (count($userIds) > 1) {
          wp_die("Please login normally - this is a statistic bug and prevents you from using login links securely!"); // TODO !!!
        }

        // Only login if there is only ONE possible user
        if (count($userIds) == 1) {
          $error_code="deleted_from_siberian";
        }else{
          $error_code="invalid_login_code";
        }
    // If something went wrong send the user to login-page (and log the old user out if there was any)
        wp_logout();
        wp_redirect($targetLogin.'?pkg_migawp_error='.$error_code.'&link='.$targetLogin);
        exit;
  }
}
// First time Binding Request
if (isset($_GET['binduser']) && isset($_GET['wp_migstone_auto_login_id']) && isset($_GET['migawp_configsite_id']) && isset($_GET['migastone_user_id']) && isset($_GET['user_email'])) {
  // Check if this email already exist then bind on both platform and login and reidrect to content url
    global $wpdb;
    $user_email   = $_GET['user_email'];
    $table_users  = $wpdb->prefix . 'users';
    $query        = "SELECT * FROM $table_users WHERE user_email='$user_email'";
    $get_users    = $wpdb->get_results($query, ARRAY_A);
    if (!empty($get_users)) {
      // 1 Locallize parms
      // 2 Update local paltform
      // 3 UPdate Module platform
      // 4 action to auto login and redirect
      if (isset($_COOKIE['migawp_autologin'])) {
        setcookie("migawp_autologin", "", time() - 3600);
      }
      // * 1
      $local_tabl_id        = $_GET['wp_migstone_auto_login_id'];
      $migastone_user_id    = $_GET['migastone_user_id'];
      $migawp_configsite_id = $_GET['migawp_configsite_id'];
      $wordpress_user_id    = $get_users[0]['ID'];
      $table_name           = $wpdb->prefix . 'migstone_auto_login';
      // * 2
      global $wpdb;
      $query                    = "SELECT * FROM $table_name WHERE id=$local_tabl_id";
      $results                  = $wpdb->get_results($query, ARRAY_A);
      if (strpos($results[0]['migastone_user_id'], $migastone_user_id) !== false) {
          $migastone_user_id_bind=$results[0]['migastone_user_id'];
      }else {
          $migastone_user_id_bind   = ($results[0]['migastone_user_id']=='0') ? $migastone_user_id : $migastone_user_id.",".$results[0]['migastone_user_id'];
      }
      if (strpos($results[0]['wordpress_user_id'], $wordpress_user_id) !== false) {
          $migawp_configsite_id_bind=$results[0]['wordpress_user_id'];
      }else {
          $migawp_configsite_id_bind=($results[0]['wordpress_user_id']=='0') ? $wordpress_user_id : $wordpress_user_id.",".$results[0]['wordpress_user_id'];
      }
      $updated                  = $wpdb->update(
                                    $table_name,
                                    array(
                                          'migastone_user_id'=> $migastone_user_id_bind,
                                          'wordpress_user_id'=> $migawp_configsite_id_bind,
                                          'updated_at'       => date('Y-m-d H:i:s')
                                        ),
                                        array('id'=> $local_tabl_id)
                                      );
      // * 3
      $query                 = "SELECT * FROM $table_name WHERE id=$local_tabl_id";
      $results               = $wpdb->get_results($query, ARRAY_A);

      $platform_url          = $results[0]['platform_url'];
      $token                 = $results[0]['token'];
      $user_exist            = get_user_by( 'id',$wordpress_user_id  );
      $user_name             = (!empty($user_exist)) ? $user_exist->data->user_login : 'appuser' ;
      $url                   = $platform_url."/migawordpress/public_api/onbinduser?login_token=".$token."&migawp_configsite_id=".$migawp_configsite_id."&wp_user_id=".$wordpress_user_id."&wp_username=".$user_name."&migastone_user_id=".$migastone_user_id;
      $res=bind_user_request($url);
      // * 4
      $targetPage  = $results[0]['site_url'];
      $userToLogin = get_user_by('id', (int) $wordpress_user_id);//Hving id like 1
      // Check if user exists
      if ($userToLogin) {
        wp_set_auth_cookie($userToLogin->ID, false);
        do_action('wp_login', $userToLogin->name, $userToLogin);
        // Create redirect URL without migawp code
        $GETQuery = pkg_migawp_generate_get_postfix();
        $protocol = (isset($_SERVER["HTTPS"]) && ($_SERVER["HTTPS"] === "on")) ? "https" : "http";
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
        header("Cache-Control: no-cache, no-store, must-revalidate, private, max-age=0, s-maxage=0");
        header("Cache-Control: post-check=0, pre-check=0", false);
        header("Pragma: no-cache");
        header("Expires: Mon, 01 Jan 1990 01:00:00 GMT");
        wp_redirect($targetPage);
        add_filter('show_admin_bar', '__return_false');
        exit;
      }
    } else {
      if (isset($_COOKIE['migawp_autologin'])) {
        setcookie("migawp_autologin", "", time() - 3600);
      }
      $json = json_encode($_GET);
      setcookie('migawp_autologin', $json);
      $error_code="bind_user";
        if ( is_user_logged_in() )
        {
            wp_logout();
        }
        global $wpdb;
        $migawp_configsite_id=$_GET['wp_migstone_auto_login_id'];
        $table_name   = $wpdb->prefix . 'migstone_auto_login';
        $query="SELECT * FROM $table_name WHERE id=$migawp_configsite_id";
        $userIds = array();
        $results = $wpdb->get_results($query, ARRAY_A);
        $targetLogin="";
        foreach ($results as $row) {
            $targetLogin=$row['login_url'];
        }
      wp_redirect($targetLogin.'?pkg_migawp_error='.$error_code);
      exit;
    }
}
add_action('init', 'get_login_trigger');
function get_login_trigger(){
    if ( is_user_logged_in() )
    {
      if (isset($_COOKIE['migawp_autologin'])) {
        $current_user         = wp_get_current_user();
        $wordpress_user_id    = $current_user->ID;
        $login_email          = $current_user->user_email;
        $cookie               = $_COOKIE['migawp_autologin'];
        $cookieee             = stripslashes($cookie);
        $saved                = json_decode($cookieee);
        $local_tabl_id        = $saved->wp_migstone_auto_login_id;
        $migastone_user_id    = $saved->migastone_user_id;
        $migawp_configsite_id = $saved->migawp_configsite_id;
        $requested_email      = $saved->user_email;
                                setcookie("migawp_autologin", "", time() - 3600);
        if ($login_email==$requested_email) {
                                  global $wpdb;
          $table_name           = $wpdb->prefix . 'migstone_auto_login';
          $query                = "SELECT * FROM $table_name WHERE id=$local_tabl_id";
          $results              = $wpdb->get_results($query, ARRAY_A);
          if (strpos($results[0]['migastone_user_id'], $migastone_user_id) !== false) {
              $migastone_user_id_bind   = $results[0]['migastone_user_id'];
          }else {
              $migastone_user_id_bind   = ($results[0]['migastone_user_id']=='0') ? $migastone_user_id : $migastone_user_id.",".$results[0]['migastone_user_id'];
          }
          if (strpos($results[0]['wordpress_user_id'], $wordpress_user_id) !== false) {
              $migawp_configsite_id_bind=$results[0]['wordpress_user_id'];
          }else {
              $migawp_configsite_id_bind=($results[0]['wordpress_user_id']=='0') ? $migastone_user_id : $migastone_user_id.",".$results[0]['wordpress_user_id'];
          }
          $updated                  = $wpdb->update(
                                        $table_name,
                                        array(
                                              'migastone_user_id'=> $migastone_user_id_bind,
                                              'wordpress_user_id'=> $migawp_configsite_id_bind,
                                              'updated_at'       => date('Y-m-d H:i:s')
                                            ),
                                            array('id'=> $local_tabl_id)
                                          );
          $query                  = "SELECT platform_url FROM $table_name WHERE id=$local_tabl_id";
          $results                = $wpdb->get_results($query, ARRAY_A);
          $platform_url           = $results[0]['platform_url'];
          $user_exist             = get_user_by( 'id',$wordpress_user_id  );
          $user_name              = (!empty($user_exist)) ? $user_exist->data->user_login : 'appuser' ;
          $url                    = $platform_url."/migawordpress/public_api/onbinduser?login_token=token&migawp_configsite_id=".$migawp_configsite_id."&wp_user_id=".$wordpress_user_id."&wp_username=".$user_name."&migastone_user_id=".$migastone_user_id;
          bind_user_request($url);
        }
      }
    }
}

function bind_user_request($url=""){
              $curl = curl_init();
              curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_SSL_VERIFYPEER=>false,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "",
                CURLOPT_HTTPHEADER => array("cache-control: no-cache"),
              ));
              $response   = curl_exec($curl);
              $err        = curl_error($curl);
              curl_close($curl);
              if ($err) {
                  return "cURL Error #:" . $err;
                } else {
                  return $response;
                }
}

// A Sample URL For bind user request: https://www.conecottage.pk/?binduser=1&wp_migstone_auto_login_id=1&migawp_configsite_id=2&migastone_user_id=3

// Section 2 Page Designing for Add session
/**
 * @internal never define functions inside callbacks.
 * these functions could be run multiple times; this would result in a fatal error.
 */

/**
 * custom option and settings
 */
function wporg_settings_init() {
 // register a new setting for "wporg" page
 register_setting( 'Miga Wordpress', 'wporg_options' );

 // register a new section in the "wporg" page
 add_settings_section(
 'wporg_section_developers',
  __( '', 'wporg' ),
  'wporg_section_developers_cb',
  'wporg'
 );

 add_settings_field(
 'wporg_field_pill', // as of WP 4.6 this value is used only internally
 // use $args' label_for to populate the id inside the callback
 __( 'Paste your Token', 'wporg' ),
      'wporg_field_pill_cb',
      'wporg',
      'wporg_section_developers',
      [
        'label_for' => 'wporg_field_pill',
        'class' => 'wporg_row',
        'wporg_custom_data' => 'custom',
      ]
    );
}

/**
 * register our wporg_settings_init to the admin_init action hook
 */
 add_action( 'admin_init', 'wporg_settings_init' );

/**
 * custom option and settings:
 * callback functions
 */

// developers section cb

// section callbacks can accept an $args parameter, which is an array.
// $args have the following keys defined: title, id, callback.
// the values are defined at the add_settings_section() function.
function wporg_section_developers_cb( $args ) {
 return 1;
}

// pill field cb

// field callbacks can accept an $args parameter, which is an array.
// $args is defined at the add_settings_field() function.
// wordpress has magic interaction with the following keys: label_for, class.
// the "label_for" key value is used for the "for" attribute of the <label>.
// the "class" key value is used for the "class" attribute of the <tr> containing the field.
// you can add custom key value pairs to be used inside your callbacks.
function wporg_field_pill_cb( $args ) {
 // get the value of the setting we've registered with register_setting()
 $options = get_option( 'wporg_options' );
 // output the field
 ?>
 <?php if (isset($_POST['migawp_token'])) { ?>
   <?php
   global $wpdb;
   $token_post   = $_POST['migawp_token'];
   $table_name   = $wpdb->prefix . 'migstone_auto_login';
   $query        = "SELECT * FROM $table_name WHERE token='$token_post'";
   $userIds = array();
   $results = $wpdb->get_results($query, ARRAY_A);
   if (!empty($results)) { ?>
     <?php
      global $wpdb;
      $table_name           = $wpdb->prefix . 'migstone_auto_login';
      $local_tabl_id=$results[0]['id'];
      $updated =$wpdb->update(
      $table_name,
      array(
      'token_bind' => 1,
      'updated_at' => date('Y-m-d H:i:s')
      ),
      array('id'=> $local_tabl_id)
      );
      ?>
     <p class="success" style="color:green;">
     <?php esc_html_e( 'Successfuly saved token.', 'wporg' ); ?>
     </p>
   <?php } else { ?>
     <p class="error" style="color:red;">
     <?php esc_html_e( 'Cannot save please try again later.', 'wporg' ); ?>
     </p>
   <?php } ?>
 <?php } ?>
 <input id="<?php echo esc_attr( $args['label_for'] ); ?>" style="width:450px;"
 data-custom="<?php echo esc_attr( $args['wporg_custom_data'] ); ?>"
 name="migawp_token"
 />
 <p class="description">
 <!-- <?php esc_html_e( 'You take the blue pill and the story ends. You wake in your bed and you believe whatever you want to believe.', 'wporg' ); ?> -->
 </p>
 <p class="description">
 <!-- <?php esc_html_e( 'You take the red pill and you stay in Wonderland and I show you how deep the rabbit-hole goes.', 'wporg' ); ?> -->
 </p>
 <?php
}

/**
 * top level menu
 */
function wporg_options_page() {
 // add top level menu page
 add_menu_page(
 'Miga Wordpress Setting',
 'Miga Wordpress',
 'manage_options',
 'wporg',
 'wporg_options_page_html'
 );
}

/**
 * register our wporg_options_page to the admin_menu action hook
 */
add_action( 'admin_menu', 'wporg_options_page' );

/**
 * top level menu:
 * callback functions
 */
function wporg_options_page_html() {
 // check user capabilities
 if ( ! current_user_can( 'manage_options' ) ) {
 return;
 }

 // add error/update messages

 // check if the user have submitted the settings
 // wordpress will add the "settings-updated" $_GET parameter to the url
 if ( isset( $_GET['settings-updated'] ) ) {
 // add settings saved message with the class of "updated"
 add_settings_error( 'wporg_messages', 'wporg_message', __( 'Settings Saved', 'wporg' ), 'updated' );
 }

 // show error/update messages
 settings_errors( 'wporg_messages' );
 ?>
 <div class="wrap">
 <h1><?php echo esc_html( get_admin_page_title() ); ?></h1>
 <form action="" method="post">
 <?php
 // output security fields for the registered setting "wporg"
 settings_fields( 'wporg' );
 // output setting sections and their fields
 // (sections are registered for "wporg", each field is registered to a specific section)
 do_settings_sections( 'wporg' );
 // output save settings button
 submit_button( 'Save Setting' );
 ?>
 </form>
 </div>
 <?php
} ?>
<?php
define('AMM_HAT_VERSION', '1.0');
define('AMM_HAT_PLUGIN_URL', plugin_dir_url(__FILE__));
define('AMM_HAT_PLUGIN_DIR', plugin_dir_path(__FILE__));

add_filter('show_admin_bar', '__return_false');
add_action('admin_print_scripts-profile.php', 'amm_hat_add_css_style');

function amm_hat_add_css_style() {
    ?>
    <style type="text/css">
        .show-admin-bar {display: none !important;}
    </style>
    <?php

}
?>
